Subject: [Fwd: Syntax problems]

From: "Prozan, Rakefet" <[email-masked]>
Date: Mon, 18 Sep 2000 10:46:12 +0300

--
Rakefet Prozan,
Team Manager, S/W Development
ATS SBU
Telrad Networks
ESN 828-3043   Email:[email-masked]

                                       """
                                     -(o o)-
+---------------------------------oOO--(_)--OOo--------------+

                               .oooO         Oooo.
-------------------------------(   )---------(   )------------
                                \ (           ) /
                                 \_)         (_/

Have fun !!!

Subject: Re: Syntax problems
From: Rakefet Prozan <[email-masked]>
To: "Taylor, Tom-PT" <[email-masked]>
Date: Mon, 18 Sep 2000 10:36:58 +0300

Hi all,
I tried to do what you have suggested regarding the contextProperties
problem (the second issue),and it seems that the problem is even worse
than I thought
at first:

 According to the following definitions,we can have actionRequest that
consist
of contextRequest.

   actionRequest        = CtxToken EQUAL ContextID LBRKT ((
                          contextRequest [COMMA  commandRequestList])
                          / commandRequestList) RBRKT

   contextRequest          = ((contextProperties [COMMA contextAudit])
                           / contextAudit)

   contextProperties    = contextProperty *(COMMA contextProperty)

   ; at-most-once
   contextProperty  = (topologyDescriptor / priority / EmergencyToken)

This contextRequest can be as follows:

topologyDescriptor,priority,EmergencyToken,contextAudit,commandRequestList

This means that after the first COMMA I can have each of the following
options:

priority,EmergencyToken,contextAudit,commandRequestList

In advance,commandRequestList can consist of:

ammRequest,subtractRequest,auditRequest,notifyRequest,serviceChangeRequest

In case that the protocol will not be changed,it means that after each
COMMA
I have to check ALL these posibilities,which doesn't make sense
(real-time,etc).
On the other hand,entering parentheses solves the problem.

By the way,the problem also exist in commandReply,because it consists of
contextProperties:

commandReply       = (( contextProperties [COMMA commandReplyList] )
                           / commandReplyList )

many thanks in advance,
 Rakefet

> "Taylor, Tom-PT" wrote:
>
> Responses below.
>
> > -----Original Message-----
> > From: Prozan, Rakefet [Partner:LOD:Telrad]
> > Sent: Tuesday, September 12, 2000 5:18 AM
> > To: [email-masked]
> > Subject: Syntax problems
> >
> >
> > Hi all,
> >
> > The previous mail was sent by mistake. This is the correct mail:
> >
> > Can someone clear the following issues in ABNF?
> >
> > 1) In APPENDIX A EXAMPLE CALL FLOW:
> >
> >    ...
> >    8.  The MGC Modifies the termination to play dial tone, to look
> for
> >    digits according to Dialplan0 and to look for the on-hook
> > event now.
> >    MGC to MG1:
> >
> >    MEGACO/1 [123.123.123.4]:55555
> >    Transaction = 10001 {
> >        Context = - {
> >            Modify = A4444 {
> >                Events = 2223 {
> >                    al/on, dd/ce {DigitMap=Dialplan0}
> >                },
> >                Signals {cg/dt},
> >                DigitMap= Dialplan0{
> >    (0| 00|[1-7]xxx|8xxxxxxx|Fxxxxxxx|Exx|91xxxxxxxxxx|9011x.)}
> >            }
> >        }
> >    }
> >
> >   According to the definition of digitMapRAnge :
> >
> >    digitMapRange = ("x" / LWSP "[" LWSP digitLetter LWSP "]" LWSP)
> >
> >
> >   "x" must be followed by "[" .
>
> [PTT] According to section 3.5 of RFC2234 (ABNF), the rule as
> currently shown is correct, but your alternative presentation would be
> clearer.
>
> >   So, either there is an error in the example,or the definition
> should
> > be:
> >
> >   digitMapRange = ("x" /( LWSP "[" LWSP digitLetter LWSP "]" LWSP ))
>
> >
> > 2) In ABNF:
> >
> >    contextRequest = ((contextProperties [COMMA contextAudit])
> >                   / contextAudit)
> >
> >    contextProperties  = contextProperty *(COMMA contextProperty)
> >
> >
> >
> > My problem is : if the parser finds a COMMA after a
> > contextProperty, it
> > doesn't have any indication to know what will come after this COMMA:
>
> > another
> > contextProperty,or the optional contextAudit. This results in a
> loop.
>
> [PTT] You have to check the keyword which follows the comma.
>
> > I think that there are two alternatives ways to solve this:
> >
> > Either to put  contextAudit in { } :
> >
> > contextRequest = ((contextProperties LBRKT [COMMA contextAudit]
> RBRKT)
> >                / contextAudit)
> >
> > Or put contextProperties in { } :
> >
> > contextRequest = ((LBRKT contextProperties RBRKT [COMMA
> contextAudit])
> >                   / contextAudit)
> >
> >
> >  thank you in advance,
> > --
> > Rakefet Prozan,
> > Team Manager, S/W Development
> > Nortel SBU
> > Telrad Networks
> > ESN 828-3043   Email:[email-masked]
> >
> >
> >                                        """
> >                                      -(o o)-
> > +---------------------------------oOO--(_)--OOo--------------+
> >
> >                                .oooO         Oooo.
> > -------------------------------(   )---------(   )------------
> >                                 \ (           ) /
> >                                  \_)         (_/
> >
> > Have fun !!!
> >

--
Rakefet Prozan,
Team Manager, S/W Development
Nortel SBU
Telrad Networks
ESN 828-3043   Email:[email-masked]

                                       """
                                     -(o o)-
+---------------------------------oOO--(_)--OOo--------------+

                               .oooO         Oooo.
-------------------------------(   )---------(   )------------
                                \ (           ) /
                                 \_)         (_/

Have fun !!!